require_relative  "baseline_red_agent/logger"
require_relative  "baseline_red_agent/plugin"
require_relative  "baseline_red_agent/dispatcher"
require_relative  "baseline_red_agent/worker"

module BaselineRedAgent
  DEFAULTS = {
    environment: nil,
    daemon: false,
    host: 'localhost:5000',
    ssl: false,
    license_key: '',
    pidfile: File.dirname(__FILE__) + "/../baseline_red_agent.pid"
  }

  def self.hostname
    @hostname ||= Socket.gethostname
  end

  def self.options
    @options ||= DEFAULTS.dup
  end

  def self.options=(opts)
    @options = opts
  end

  def self.logger
    BaselineRedAgent::Logger.logger
  end

  def self.logger=(log)
    BaselineRedAgent::Logger.logger = log
  end

  class << self
    def load
      BaselineRedAgent::Agent::Plugin.load_plugins
    end
  end
end
