module BaselineRedAgent
  module Plugin
    class << self
      def load_plugins
        pattern = File.join(File.dirname(__FILE__), 'plugin', '**', '*.rb')

        Dir.glob(pattern) do |f|
          begin
            require f
          rescue => e
            BaselineRedAgent.logger.info "Error loading plugin '#{f}' : #{e}"
            BaselineRedAgent.logger.info "#{e.backtrace.first}"
          end
        end
      end

      def plugins
        @plugins ||= ::BaselineRedAgent::Plugin::Base
          .descendants
          .map(&:new)
      end
    end
  end
end
